/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2210 from the
 * contents of RPM2.xs. Do not edit this file, edit RPM2.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "lib/RPM2.xs"
#include <stdio.h>
#include <string.h>
#include <rpm/rpmcli.h>

#define RPM_VERSION(major,minor) (major*1000+minor)

#include <rpm/rpmts.h>
#include <rpm/rpmte.h>
#include <rpm/rpmdb.h>

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* Chip, this is somewhat stripped down from the default callback used by
   the rpmcli.  It has to be here to insure that we open the pkg again. 
   If we don't do this we get segfaults.  I also, kept the updating of some
   of the rpmcli static vars, but I may not have needed to do this.

   Also, we probably want to give a nice interface such that we could allow
   users of RPM2 to do their own callback, but that will have to come later.
*/
void * _null_callback(
	const void * arg, 
	const rpmCallbackType what,
	const rpm_loff_t amount,
	const rpm_loff_t total,
	fnpyKey key, 
	rpmCallbackData data)
{
	Header h = (Header) arg;
	int flags = (int) ((long)data);
	void * rc = NULL;
	const char * filename = (const char *)key;
	static FD_t fd = NULL;
	int xx;

	/* Code stolen from rpminstall.c and modified */
	switch(what) {
		case RPMCALLBACK_INST_OPEN_FILE:
	 		if (filename == NULL || filename[0] == '\0')
			     return NULL;
			fd = Fopen(filename, "r.ufdio");
			/* FIX: still necessary? */
			if (fd == NULL || Ferror(fd)) {
				fprintf(stderr, "open of %s failed!\n", filename);
				if (fd != NULL) {
					xx = Fclose(fd);
					fd = NULL;
				}
			} else
#if RPM2_API < RPM_VERSION(4,9)
				fd = fdLink(fd, "persist (showProgress)");
#else
				fd = fdLink(fd);
#endif
			return (void *)fd;
	 		break;

	case RPMCALLBACK_INST_CLOSE_FILE:
		/* FIX: still necessary? */
#if RPM2_API < RPM_VERSION(4,9)
				fd = fdFree(fd, "persist (showProgress)");
#else
				fd = fdFree(fd);
#endif
		if (fd != NULL) {
			xx = Fclose(fd);
			fd = NULL;
		}
		break;

	case RPMCALLBACK_INST_START:
		rpmcliHashesCurrent = 0;
		if (h == NULL || !(flags & INSTALL_LABEL))
			break;
		break;

	case RPMCALLBACK_TRANS_PROGRESS:
	case RPMCALLBACK_INST_PROGRESS:
		break;

	case RPMCALLBACK_TRANS_START:
		rpmcliHashesCurrent = 0;
		rpmcliProgressTotal = 1;
		rpmcliProgressCurrent = 0;
		break;

	case RPMCALLBACK_TRANS_STOP:
		rpmcliProgressTotal = rpmcliPackagesTotal;
		rpmcliProgressCurrent = 0;
		break;

	case RPMCALLBACK_REPACKAGE_START:
		rpmcliHashesCurrent = 0;
		rpmcliProgressTotal = total;
		rpmcliProgressCurrent = 0;
		break;

	case RPMCALLBACK_REPACKAGE_PROGRESS:
		break;

	case RPMCALLBACK_REPACKAGE_STOP:
		rpmcliProgressTotal = total;
		rpmcliProgressCurrent = total;
		rpmcliProgressTotal = rpmcliPackagesTotal;
		rpmcliProgressCurrent = 0;
		break;

	case RPMCALLBACK_UNINST_PROGRESS:
		break;
	case RPMCALLBACK_UNINST_START:
		break;
	case RPMCALLBACK_UNINST_STOP:
		break;
	case RPMCALLBACK_UNPACK_ERROR:
		break;
	case RPMCALLBACK_CPIO_ERROR:
		break;
	case RPMCALLBACK_UNKNOWN:
		break;
	default:
		break;
	}
	
	return rc;	
}

void
_populate_header_tags(HV *href)
{
    rpmtd names;
    const char *name;

    names = rpmtdNew();
    rpmTagGetNames(names, 1);
    while ((name = rpmtdNextString(names)) != NULL) {
        (void)hv_store(href, name, strlen(name),
            newSViv(rpmTagGetValue(name + strlen("RPMTAG_"))), 0);
    }
}

void
_populate_constant(HV *href, char *name, int val)
{
    (void)hv_store(href, name, strlen(name), newSViv(val), 0);
}

#define REGISTER_CONSTANT(name) _populate_constant(constants, #name, name)

#line 161 "lib/RPM2.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 213 "lib/RPM2.c"

XS(XS_RPM2_rpm_api_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2_rpm_api_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	char *	pkg = (char *)SvPV_nolen(ST(0));
	double	RETVAL;
	dXSTARG;
#line 188 "lib/RPM2.xs"
	(void)pkg; /* Not used */
	int major = RPM2_API / 1000;
	double minor = (int)RPM2_API % 1000;
	while (minor >= 1) { minor /= 10; }
	RETVAL = major + minor;
#line 235 "lib/RPM2.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2_add_macro); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2_add_macro)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "pkg, name, val");
    {
	char *	pkg = (char *)SvPV_nolen(ST(0));
	char *	name = (char *)SvPV_nolen(ST(1));
	char *	val = (char *)SvPV_nolen(ST(2));
#line 203 "lib/RPM2.xs"
	(void)pkg; /* Not used */
	addMacro(NULL, name, NULL, val, RMIL_DEFAULT);
#line 259 "lib/RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2_delete_macro); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2_delete_macro)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, name");
    {
	char *	pkg = (char *)SvPV_nolen(ST(0));
	char *	name = (char *)SvPV_nolen(ST(1));
#line 211 "lib/RPM2.xs"
	(void)pkg; /* Not used */
	delMacro(NULL, name);
#line 281 "lib/RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2_expand_macro); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2_expand_macro)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, str");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	pkg = (char *)SvPV_nolen(ST(0));
	char *	str = (char *)SvPV_nolen(ST(1));
#line 219 "lib/RPM2.xs"
	char *ret;
#line 304 "lib/RPM2.c"
#line 221 "lib/RPM2.xs"
	(void)pkg; /* Not used */
	ret = rpmExpand(str, NULL);
	PUSHs(sv_2mortal(newSVpv(ret, 0)));
	free(ret);
#line 310 "lib/RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2_rpmvercmp); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2_rpmvercmp)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "one, two");
    {
	char*	one = (char *)SvPV_nolen(ST(0));
	char*	two = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

	RETVAL = rpmvercmp(one, two);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__read_package_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__read_package_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "fp, vsflags");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	FILE *	fp = PerlIO_findFILE(IoIFP(sv_2io(ST(0))));
	int	vsflags = (int)SvIV(ST(1));
#line 236 "lib/RPM2.xs"
	rpmts ts;
	Header ret;
	rpmRC rc;
	FD_t fd;
#line 360 "lib/RPM2.c"
#line 241 "lib/RPM2.xs"
	ts = rpmtsCreate();

        /* XXX Determine type of signature verification when reading
	vsflags |= _RPMTS_VSF_NOLEGACY;
	vsflags |= _RPMTS_VSF_NODIGESTS;
	vsflags |= _RPMTS_VSF_NOSIGNATURES;
	xx = rpmtsSetVerifySigFlags(ts, vsflags);
        */ 

	fd = fdDup(fileno(fp));
	rpmtsSetVSFlags(ts, vsflags);
	rc = rpmReadPackageFile(ts, fd, "filename or other identifier", &ret);

	Fclose(fd);

	if (rc == RPMRC_OK) {
	    SV *h_sv;

	    EXTEND(SP, 1);

	    h_sv = sv_newmortal();
            sv_setref_pv(h_sv, "RPM2::C::Header", (void *)ret);

	    PUSHs(h_sv);
	}
	else {
	    croak("error reading package");
	}
	ts = rpmtsFree(ts);
#line 391 "lib/RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__create_transaction); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__create_transaction)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vsflags");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	vsflags = (int)SvIV(ST(0));
#line 275 "lib/RPM2.xs"
	rpmts ret;
	SV *h_sv;
#line 415 "lib/RPM2.c"
#line 278 "lib/RPM2.xs"
	/* Looking at librpm, it does not look like this ever
	   returns error (though maybe it should).
	*/
	ret = rpmtsCreate();

	/* Should I save the old vsflags aside? */
	rpmtsSetVSFlags(ret, vsflags);

	/* Convert and throw the results on the stack */	
	EXTEND(SP, 1);

	h_sv = sv_newmortal();
	sv_setref_pv(h_sv, "RPM2::C::Transaction", (void *)ret);

	PUSHs(h_sv);
#line 432 "lib/RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__read_from_file); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__read_from_file)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	FILE *	fp = PerlIO_findFILE(IoIFP(sv_2io(ST(0))));
#line 298 "lib/RPM2.xs"
	SV *h_sv;
	FD_t fd;
	Header h;
#line 457 "lib/RPM2.c"
#line 302 "lib/RPM2.xs"
	fd = fdDup(fileno(fp));
	h = headerRead(fd, HEADER_MAGIC_YES);

	if (h) {
	    EXTEND(SP, 1);

	    h_sv = sv_newmortal();
	    sv_setref_pv(h_sv, "RPM2::C::Header", (void *)h);

	    PUSHs(h_sv);
	}
	Fclose(fd);
#line 471 "lib/RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__open_rpm_db); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__open_rpm_db)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "for_write");
    {
	int	for_write = (int)SvIV(ST(0));
#line 319 "lib/RPM2.xs"
	 rpmts ts;
#line 492 "lib/RPM2.c"
	rpmts	RETVAL;
#line 321 "lib/RPM2.xs"
	ts = rpmtsCreate();
	if (rpmtsOpenDB(ts, for_write ? O_RDWR : O_RDONLY)) {
		croak("rpmtsOpenDB failed");
		RETVAL = NULL;
	}
	RETVAL = ts;
#line 501 "lib/RPM2.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "RPM2::C::Transaction", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__DB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__DB_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ts");
    {
	rpmts	ts;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ts = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::DB::DESTROY() -- ts is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 336 "lib/RPM2.xs"
	rpmtsCloseDB(ts);
	rpmtsFree(ts);
#line 531 "lib/RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2__C__DB__close_rpm_db); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__DB__close_rpm_db)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	rpmts	self;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        self = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::DB::_close_rpm_db() -- self is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 343 "lib/RPM2.xs"
	rpmtsCloseDB(self);
	rpmtsFree(self);
#line 559 "lib/RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2__C__DB__init_iterator); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__DB__init_iterator)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "ts, rpmtag, key, len");
    {
	rpmts	ts;
	int	rpmtag = (int)SvIV(ST(1));
	char *	key = (char *)SvPV_nolen(ST(2));
	size_t	len = (size_t)SvUV(ST(3));
	rpmdbMatchIterator	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ts = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::DB::_init_iterator() -- ts is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 353 "lib/RPM2.xs"
    /* See rpmtsInitIterator() code for explanation of this */
	if (rpmtag == RPMDBI_PACKAGES) {
		len = strlen (key);
	}

	RETVAL = rpmtsInitIterator(ts, rpmtag, len ? key : NULL, len);
#line 595 "lib/RPM2.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "RPM2::C::PackageIterator", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__PackageIterator__iterator_next); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__PackageIterator__iterator_next)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "i");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	rpmdbMatchIterator	i;
#line 367 "lib/RPM2.xs"
	Header       ret;
        SV *         h_sv;
	unsigned int offset;
#line 621 "lib/RPM2.c"
	Header	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        i = (rpmdbMatchIterator)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::PackageIterator::_iterator_next() -- i is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 371 "lib/RPM2.xs"
	ret = rpmdbNextIterator(i);
	if (ret)
		headerLink(ret);
	if(ret != NULL) 
		offset = rpmdbGetIteratorOffset(i);
	else
		offset = 0;

	EXTEND(SP, 2);
	h_sv = sv_newmortal();
	sv_setref_pv(h_sv, "RPM2::C::Header", (void *)ret);
	PUSHs(h_sv);
	PUSHs(sv_2mortal(newSViv(offset)));
        RETVAL = ret;
#line 645 "lib/RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__C__PackageIterator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__PackageIterator_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "i");
    {
	rpmdbMatchIterator	i;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        i = (rpmdbMatchIterator)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::PackageIterator::DESTROY() -- i is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 390 "lib/RPM2.xs"
	rpmdbFreeIterator(i);
#line 673 "lib/RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2__C__Header_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Header_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "h");
    {
	Header	h;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        h = (Header)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Header::DESTROY() -- h is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 399 "lib/RPM2.xs"
	headerFree(h);
#line 700 "lib/RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2__C__Header_tag_by_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Header_tag_by_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "h, tag");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Header	h;
	int	tag = (int)SvIV(ST(1));
#line 406 "lib/RPM2.xs"
	rpmtd tagdata;
	int ok;
#line 724 "lib/RPM2.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        h = (Header)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Header::tag_by_id() -- h is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 409 "lib/RPM2.xs"
	tagdata = rpmtdNew();
	if (tagdata == NULL) {
		croak("Out of memory");
	}
	ok = headerGet(h, tag, tagdata, HEADERGET_DEFAULT);

	if (!ok) {
		/* nop, empty stack */
	}
	else {
		switch(tagdata->type)
		{
		case RPM_STRING_ARRAY_TYPE:
			{
			int i;
			char **s;

			EXTEND(SP, tagdata->count);
			s = (char **)tagdata->data;

			for (i = 0; i < tagdata->count; i++) {
				PUSHs(sv_2mortal(newSVpv(s[i], 0)));
			}
			}
			break;
		case RPM_STRING_TYPE:
			PUSHs(sv_2mortal(newSVpv((char *)tagdata->data, 0)));
			break;
		case RPM_CHAR_TYPE:
			{
			int i;
			char *r;

			EXTEND(SP, tagdata->count);
			r = (char *)tagdata->data;

			for (i = 0; i < tagdata->count; i++) {
				PUSHs(sv_2mortal(newSViv(r[i])));
			}
			}
			break;
		case RPM_INT8_TYPE:
			{
			int i;
			uint8_t *r;

			EXTEND(SP, tagdata->count);
			r = (uint8_t *)tagdata->data;

			for (i = 0; i < tagdata->count; i++) {
				PUSHs(sv_2mortal(newSViv(r[i])));
			}
			}
			break;
		case RPM_INT16_TYPE:
			{
			int i;
			uint16_t *r;

			EXTEND(SP, tagdata->count);
			r = (uint16_t *)tagdata->data;

			for (i = 0; i < tagdata->count; i++) {
				PUSHs(sv_2mortal(newSViv(r[i])));
			}
			}
			break;
		case RPM_INT32_TYPE:
			{
			int i;
			uint32_t *r;

			EXTEND(SP, tagdata->count);
			r = (uint32_t *)tagdata->data;

			for (i = 0; i < tagdata->count; i++) {
				PUSHs(sv_2mortal(newSViv(r[i])));
			}
			}
			break;
		default:
			croak("unknown rpm tag type %d", tagdata->type);
		}
	}
	rpmtdFreeData(tagdata);
#line 818 "lib/RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__C__Header__header_compare); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Header__header_compare)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "h1, h2");
    {
	Header	h1;
	Header	h2;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        h1 = (Header)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Header::_header_compare() -- h1 is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        h2 = (Header)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "RPM2::C::Header::_header_compare() -- h2 is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 500 "lib/RPM2.xs"
	RETVAL = rpmVersionCompare(h1, h2);
#line 856 "lib/RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Header__header_is_source); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Header__header_is_source)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "h");
    {
	Header	h;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        h = (Header)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Header::_header_is_source() -- h is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 508 "lib/RPM2.xs"
	RETVAL = headerIsEntry(h, RPMTAG_SOURCEPACKAGE);
#line 886 "lib/RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Header__header_sprintf); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Header__header_sprintf)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "h, format");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Header	h;
	char *	format = (char *)SvPV_nolen(ST(1));
#line 517 "lib/RPM2.xs"
	char * s;
#line 910 "lib/RPM2.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        h = (Header)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Header::_header_sprintf() -- h is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 519 "lib/RPM2.xs"
	s =  headerFormat(h, format, NULL);
	PUSHs(sv_2mortal(newSVpv((char *)s, 0)));
/* By the way, the #if below is completely useless, free() would work for both */
	free(s);
#line 923 "lib/RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__C__Transaction_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "t");
    {
	rpmts	t;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::DESTROY() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 531 "lib/RPM2.xs"
	t = rpmtsFree(t);
#line 951 "lib/RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2__C__Transaction__add_install); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__add_install)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "t, h, fn, upgrade");
    {
	rpmts	t;
	Header	h;
	char *	fn = (char *)SvPV_nolen(ST(2));
	int	upgrade = (int)SvIV(ST(3));
#line 541 "lib/RPM2.xs"
	rpmRC rc = 0;
#line 974 "lib/RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_add_install() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        h = (Header)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "RPM2::C::Transaction::_add_install() -- h is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 543 "lib/RPM2.xs"
	rc = rpmtsAddInstallElement(t, h, (fnpyKey) fn, upgrade, NULL);
	RETVAL = (rc == RPMRC_OK) ? 1 : 0;
#line 994 "lib/RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Transaction__add_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__add_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "t, h, offset");
    {
	rpmts	t;
	Header	h;
	unsigned int	offset = (unsigned int)SvUV(ST(2));
#line 554 "lib/RPM2.xs"
	rpmRC rc = 0;
#line 1017 "lib/RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_add_delete() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        h = (Header)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "RPM2::C::Transaction::_add_delete() -- h is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 556 "lib/RPM2.xs"
	rc = rpmtsAddEraseElement(t, h, offset);
	RETVAL = (rc == RPMRC_OK) ? 1 : 0;
#line 1037 "lib/RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Transaction__element_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__element_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "t");
    {
	rpmts	t;
#line 565 "lib/RPM2.xs"
	int ret;
#line 1058 "lib/RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_element_count() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 567 "lib/RPM2.xs"
	ret    = rpmtsNElements(t);
	RETVAL = ret;
#line 1071 "lib/RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Transaction__close_db); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__close_db)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "t");
    {
	rpmts	t;
#line 576 "lib/RPM2.xs"
	int ret;
#line 1092 "lib/RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_close_db() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 578 "lib/RPM2.xs"
	ret    = rpmtsCloseDB(t);
	RETVAL = (ret == 0) ? 1 : 0;
#line 1105 "lib/RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Transaction__check); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__check)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "t");
    {
	rpmts	t;
#line 587 "lib/RPM2.xs"
	int ret;
#line 1126 "lib/RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_check() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 589 "lib/RPM2.xs"
	ret    = rpmtsCheck(t);
	RETVAL = (ret == 0) ? 1 : 0;
#line 1139 "lib/RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Transaction__order); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__order)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "t");
    {
	rpmts	t;
#line 598 "lib/RPM2.xs"
	int ret;
#line 1160 "lib/RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_order() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 600 "lib/RPM2.xs"
	ret    = rpmtsOrder(t);
	/* XXX:  May want to do something different here.  It actually
	         returns the number of non-ordered elements...maybe we
	         want this?
	*/
	RETVAL = (ret == 0) ? 1 : 0;
#line 1177 "lib/RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Transaction__elements); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__elements)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "t, type");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	rpmts	t;
	rpmElementType	type = (rpmElementType)SvIV(ST(1));
#line 614 "lib/RPM2.xs"
	rpmtsi       i;
	rpmte        te;
	const char * NEVR;
#line 1203 "lib/RPM2.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_elements() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 618 "lib/RPM2.xs"
	i = rpmtsiInit(t);
	if(i == NULL) {
		printf("Did not get a thing!\n");
		return;	
	} else {
		while((te = rpmtsiNext(i, type)) != NULL) {
			NEVR = rpmteNEVR(te);
			XPUSHs(sv_2mortal(newSVpv(NEVR,	0)));
		}
		i = rpmtsiFree(i);
	}
#line 1223 "lib/RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__C__Transaction__run); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__run)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "t, ok_probs, prob_filter");
    {
	rpmts	t;
	rpmprobFilterFlags	prob_filter = (rpmprobFilterFlags)SvIV(ST(2));
#line 635 "lib/RPM2.xs"
	int ret;
#line 1245 "lib/RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_run() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 637 "lib/RPM2.xs"
	/* Make sure we could run this transactions */
	ret = rpmtsCheck(t);
	if (ret != 0) {
		RETVAL = 0;
		return;
	}
	ret = rpmtsOrder(t);
	if (ret != 0) {
		RETVAL = 0;
		return;
	}

	/* XXX:  Should support callbacks eventually */
	(void) rpmtsSetNotifyCallback(t, _null_callback, (void *) ((long)0));
	ret    = rpmtsRun(t, NULL, prob_filter);
	RETVAL = (ret == 0) ? 1 : 0;
#line 1272 "lib/RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_RPM2); /* prototype to pass -Wmissing-prototypes */
XS(boot_RPM2)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK ;

        (void)newXSproto_portable("RPM2::rpm_api_version", XS_RPM2_rpm_api_version, file, "$");
        (void)newXSproto_portable("RPM2::add_macro", XS_RPM2_add_macro, file, "$$$");
        (void)newXSproto_portable("RPM2::delete_macro", XS_RPM2_delete_macro, file, "$$");
        (void)newXSproto_portable("RPM2::expand_macro", XS_RPM2_expand_macro, file, "$$");
        (void)newXSproto_portable("RPM2::rpmvercmp", XS_RPM2_rpmvercmp, file, "$$");
        (void)newXSproto_portable("RPM2::_read_package_info", XS_RPM2__read_package_info, file, "$$");
        (void)newXSproto_portable("RPM2::_create_transaction", XS_RPM2__create_transaction, file, "$");
        (void)newXSproto_portable("RPM2::_read_from_file", XS_RPM2__read_from_file, file, "$");
        (void)newXSproto_portable("RPM2::_open_rpm_db", XS_RPM2__open_rpm_db, file, "$");
        (void)newXSproto_portable("RPM2::C::DB::DESTROY", XS_RPM2__C__DB_DESTROY, file, "$");
        (void)newXSproto_portable("RPM2::C::DB::_close_rpm_db", XS_RPM2__C__DB__close_rpm_db, file, "$");
        (void)newXSproto_portable("RPM2::C::DB::_init_iterator", XS_RPM2__C__DB__init_iterator, file, "$$$$");
        (void)newXSproto_portable("RPM2::C::PackageIterator::_iterator_next", XS_RPM2__C__PackageIterator__iterator_next, file, "$");
        (void)newXSproto_portable("RPM2::C::PackageIterator::DESTROY", XS_RPM2__C__PackageIterator_DESTROY, file, "$");
        (void)newXSproto_portable("RPM2::C::Header::DESTROY", XS_RPM2__C__Header_DESTROY, file, "$");
        (void)newXSproto_portable("RPM2::C::Header::tag_by_id", XS_RPM2__C__Header_tag_by_id, file, "$$");
        (void)newXSproto_portable("RPM2::C::Header::_header_compare", XS_RPM2__C__Header__header_compare, file, "$$");
        (void)newXSproto_portable("RPM2::C::Header::_header_is_source", XS_RPM2__C__Header__header_is_source, file, "$");
        (void)newXSproto_portable("RPM2::C::Header::_header_sprintf", XS_RPM2__C__Header__header_sprintf, file, "$$");
        (void)newXSproto_portable("RPM2::C::Transaction::DESTROY", XS_RPM2__C__Transaction_DESTROY, file, "$");
        (void)newXSproto_portable("RPM2::C::Transaction::_add_install", XS_RPM2__C__Transaction__add_install, file, "$$$$");
        (void)newXSproto_portable("RPM2::C::Transaction::_add_delete", XS_RPM2__C__Transaction__add_delete, file, "$$$");
        (void)newXSproto_portable("RPM2::C::Transaction::_element_count", XS_RPM2__C__Transaction__element_count, file, "$");
        (void)newXSproto_portable("RPM2::C::Transaction::_close_db", XS_RPM2__C__Transaction__close_db, file, "$");
        (void)newXSproto_portable("RPM2::C::Transaction::_check", XS_RPM2__C__Transaction__check, file, "$");
        (void)newXSproto_portable("RPM2::C::Transaction::_order", XS_RPM2__C__Transaction__order, file, "$");
        (void)newXSproto_portable("RPM2::C::Transaction::_elements", XS_RPM2__C__Transaction__elements, file, "$$");
        (void)newXSproto_portable("RPM2::C::Transaction::_run", XS_RPM2__C__Transaction__run, file, "$$$");

    /* Initialisation Section */

#line 155 "lib/RPM2.xs"
    {
	HV *header_tags, *constants;
	rpmReadConfigFiles(NULL, NULL);

	header_tags = perl_get_hv("RPM2::header_tag_map", TRUE);
	_populate_header_tags(header_tags);

	constants = perl_get_hv("RPM2::constants", TRUE);

	/* not the 'standard' way of doing perl constants, but a lot easier to maintain */
	REGISTER_CONSTANT(RPMVSF_DEFAULT);
	REGISTER_CONSTANT(RPMVSF_NOHDRCHK);
	REGISTER_CONSTANT(RPMVSF_NEEDPAYLOAD);
	REGISTER_CONSTANT(RPMVSF_NOSHA1HEADER);
	REGISTER_CONSTANT(RPMVSF_NOMD5HEADER);
	REGISTER_CONSTANT(RPMVSF_NODSAHEADER);
	REGISTER_CONSTANT(RPMVSF_NORSAHEADER);
	REGISTER_CONSTANT(RPMVSF_NOSHA1);
	REGISTER_CONSTANT(RPMVSF_NOMD5);
	REGISTER_CONSTANT(RPMVSF_NODSA);
	REGISTER_CONSTANT(RPMVSF_NORSA);
	REGISTER_CONSTANT(_RPMVSF_NODIGESTS);
	REGISTER_CONSTANT(_RPMVSF_NOSIGNATURES);
	REGISTER_CONSTANT(_RPMVSF_NOHEADER);
	REGISTER_CONSTANT(_RPMVSF_NOPAYLOAD);
	REGISTER_CONSTANT(TR_ADDED);
	REGISTER_CONSTANT(TR_REMOVED);
    }

#line 1363 "lib/RPM2.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

